Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections
Interface BidiMap

All Superinterfaces:
  IterableMap, java.util.Map

All Known Subinterfaces:
  OrderedBidiMap, SortedBidiMap

All Known Implementing Classes:
  AbstractBidiMapDecorator, AbstractDualBidiMap, AbstractOrderedBidiMapDecorator, AbstractSortedBidiMapDecorator, DualHashBidiMap, DualTreeBidiMap, TreeBidiMap, UnmodifiableBidiMap, UnmodifiableOrderedBidiMap, UnmodifiableSortedBidiMap

    public interface BidiMap

extends IterableMap

Defines a map that allows bidirectional lookup between key and values.

This extended `Map` represents a mapping where a key may lookup a value and a value may lookup a key with equal ease. This interface extends `Map` and so may be used anywhere a map is required. The interface provides an inverse map view, enabling full access to both directions of the `BidiMap`.

Implementations should allow a value to be looked up from a key and a key to be looked up from a value with equal performance.

This map enforces the restriction that there is a 1:1 relation between keys and values, meaning that multiple keys cannot map to the same value. This is required so that "inverting" the map results in a map without duplicate keys. See the `put(java.lang.Object, java.lang.Object)` method description for more information.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne

Nested Class Summary

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Method Summary
`java.lang.Object` | `getKey(java.lang.Object value)` Gets the key that is currently mapped to the specified value.
`BidiMap` | `inverseBidiMap()` Gets a view of this map where the keys and values are reversed.
`MapIterator` | `mapIterator()` Obtains a `MapIterator` over the map.
`java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)` Puts the key-value pair into the map, replacing any previous pair.
`java.lang.Object` | `removeValue(java.lang.Object value)` Removes the key-value pair that is currently mapped to the specified value (optional operation).

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, putAll, remove, size, values`

Method Detail

### mapIterator

    MapIterator mapIterator()

  Obtains a `MapIterator` over the map.

  A map iterator is an efficient way of iterating over maps. It does not require that the map is stored using Map Entry objects which can increase performance.

       BidiMap map = new DualHashBidiMap();
       MapIterator it = map.mapIterator();
       while (it.hasNext()) {
         Object key = it.next();
         Object value = it.getValue();
         it.setValue("newValue");
       }

  Specified by:
    `mapIterator` in interface `IterableMap`
  Returns:
    a map iterator

### put

    java.lang.Object put(java.lang.Object key,
                         java.lang.Object value)

  Puts the key-value pair into the map, replacing any previous pair.

  When adding a key-value pair, the value may already exist in the map against a different key. That mapping is removed, to ensure that the value only occurs once in the inverse map.

        BidiMap map1 = new DualHashBidiMap();
        map.put("A","B");  // contains A mapped to B, as per Map
        map.put("A","C");  // contains A mapped to C, as per Map

        BidiMap map2 = new DualHashBidiMap();
        map.put("A","B");  // contains A mapped to B, as per Map
        map.put("C","B");  // contains C mapped to B, key A is removed

  Specified by:
    `put` in interface `java.util.Map`
  Parameters:
    `key` - the key to store
    `value` - the value to store
  Returns:
    the previous value mapped to this key
  Throws:
    `java.lang.UnsupportedOperationException` - if the `put` method is not supported
    `java.lang.ClassCastException` - (optional) if the map limits the type of the value and the specified value is inappropriate
    `java.lang.IllegalArgumentException` - (optional) if the map limits the values in some way and the value was invalid
    `java.lang.NullPointerException` - (optional) if the map limits the values to non-null and null was specified

### getKey

    java.lang.Object getKey(java.lang.Object value)

  Gets the key that is currently mapped to the specified value.

  If the value is not contained in the map, `null` is returned.

  Implementations should seek to make this method perform equally as well as `get(Object)`.

  Parameters:
    `value` - the value to find the key for
  Returns:
    the mapped key, or `null` if not found
  Throws:
    `java.lang.ClassCastException` - (optional) if the map limits the type of the value and the specified value is inappropriate
    `java.lang.NullPointerException` - (optional) if the map limits the values to non-null and null was specified

### removeValue

    java.lang.Object removeValue(java.lang.Object value)

  Removes the key-value pair that is currently mapped to the specified value (optional operation).

  If the value is not contained in the map, `null` is returned.

  Implementations should seek to make this method perform equally as well as `remove(Object)`.

  Parameters:
    `value` - the value to find the key-value pair for
  Returns:
    the key that was removed, `null` if nothing removed
  Throws:
    `java.lang.ClassCastException` - (optional) if the map limits the type of the value and the specified value is inappropriate
    `java.lang.NullPointerException` - (optional) if the map limits the values to non-null and null was specified
    `java.lang.UnsupportedOperationException` - if this method is not supported by the implementation

### inverseBidiMap

    BidiMap inverseBidiMap()

  Gets a view of this map where the keys and values are reversed.

  Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed as a `Map`.

  Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

  Returns:
    an inverted bidirectional map

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.